# @Copyright (c) 1997-1998 The Regents of the University of California.
# All rights reserved.
# 
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in all
# copies of this software.
# 
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
# THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
# 
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
# CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
# ENHANCEMENTS, OR MODIFICATIONS.
# 
# 						PT_COPYRIGHT_VERSION_2
# 						COPYRIGHTENDKEY
# test.tcl
#
# File to demonstrate the Tycho scheduler with
# a sample CGC "task" generated by the Ptolemy
# Tycho target.
#
# @(#)test.tcl	1.3 04/29/98
#

# Load the package
::tycho::loadIfNotPresent ::tycho::timer tytimer
::tycho::loadIfNotPresent ::tycho::cgctest cgctest

# Initialize the iteration counter
set counter 0

catch {destroy .t}
toplevel .t

# Create a label which prints the counter value
label .t.l -textvariable counter -width 8 \
        -font [::tycho::font Helvetica 24]
frame .t.buttons

# This button adds a task to the scheduler.
button .t.start -text Start -command {
    ::tycho::Scheduler::startC ::tycho::cgctest counter
}

# This button pauses the task
button .t.pause  -text Pause  -command {
    ::tycho::Scheduler::suspend cgctest
}

# This button resumes the task
button .t.resume  -text Resume  -command {
    ::tycho::Scheduler::resume cgctest
}

# This button kills the task
button .t.stop  -text Stop -command {
    ::tycho::Scheduler::kill cgctest
}

pack .t.l -fill x -expand on
pack .t.buttons -fill x -expand on
pack .t.start -in .t.buttons -side left
pack .t.pause -in .t.buttons -side left
pack .t.resume -in .t.buttons -side left
pack .t.stop -in .t.buttons -side left


# It's handy to have a button to close the window
button .t.close  -text Close -command {
    catch {::tycho::Scheduler::kill cgctest}
    destroy .t
}
pack .t.close -in .t.buttons -side left


wm deiconify .t
